/**
 * @author Guillaume Santini
 * @version 1.0
 * Classe entitée permettant de décrire une opération d'addition
 */
public class Addition extends Operation {

	/**
	 * Constructeur par champs.
	 * @param op1 premier terme de l'addition
	 * @param op2 deuxième terme de l'addition
	 */
	public Addition(Expression op1, Expression op2) {
		super(op1,op2);
	}

	/**
	 * Getter permettant d'accéder à la valeur numérique résultat d'une addition.
	 */
	public Double valeur() {
		return this.getOperande1().valeur() + this.getOperande2().valeur();
	}

	/**
	 * Redéfinition de la méthode représentant l'état d'une instance d'Addition.
	 */
	public String toString() {
		return "( " + this.getOperande1().toString() + " + " + this.getOperande2().toString() +")";
	}
}
