/**
 * @author Guillaume Santini
 * @version 1.0
 * Classe entitée permettant de décrire une opération de division
 */
public class Division extends Operation {
	
	/**
	 * Constructeur par champs.
	 * @param op1 premier terme de la division
	 * @param op2 deuxième terme de la division
	 */
	public Division(Expression op1, Expression op2) {
		super(op1,op2);
	}
	
	/**
	 * Getter permettant d'accéder à la valeur numérique résultat d'une division.
	*/
	public Double valeur() {
		return this.getOperande1().valeur() / this.getOperande2().valeur();
	}
	
	/**
	 * Redéfinition de la méthode représentant l'état d'une instance de Division.
	 */
	public String toString() {
		return "( " + this.getOperande1().toString() + " / " + this.getOperande2().toString() + ")";
	}
}
