/**
 * @author Guillaume Santini
 * @version 1.0
 * Classe asbtraite permettant de décrire une expression algébrique dont les
 * termes peuvent être des Nombres, des opérations sur des Nombres ou de
 * opération sur des opération.
 * 
 * La classe est le Composite du patron de conception Composite. Elle introduit
 * des comportements par défaut pour chacune des opérations utilisée par les
 * Feuilles ou les composants.
 */
public abstract class Expression {
	
	/**
	 * Getter abstrait à redéfinir dans la classe Operation permettant d'accéder à la valeur du premier opérande d'une opération.
	*/
	public Expression getOperande1() {
		return null;
	}
	
	/**
	 * Getter abstrait à redéfinir dans la classe Operation permettant d'accéder à la valeur du deuxième opérande d'une opération.
	*/
	public Expression getOperande2() {
		return null;
	}
	
	/**
	 * Contrat abstrait à redifinir pour retourner la valeur numérique résultat d'un Nombre ou d'une opération.
	*/
	public Double valeur() {
		return 0.;
	}

	/**
	 * Redéfinition de la méthode représentant l'état d'une instance, à redéfinir dans chaque classe concrète
	 * de Nombre ou d'opération.
	 */
public String toString() {
		return "";
	};
}
