/**
 * @author Guillaume Santini
 * @version 1.0
 * Classe entitée permettant de décrire une opération de division
 */
public class Multiplication extends Operation {
	
	/**
	 * Constructeur par champs.
	 * @param op1 premier terme de la multiplication
	 * @param op2 deuxième terme de la multiplication
	 */
	public Multiplication(Expression op1, Expression op2) {
		super(op1,op2);
	}
	
	/**
	 * Getter permettant d'accéder à la valeur numérique résultat d'une multiplication.
	*/
	public Double valeur() {
		return this.getOperande1().valeur() * this.getOperande2().valeur();
	}
	
	/**
	 * Redéfinition de la méthode représentant l'état d'une instance de Multiplication.
	 */
	public String toString() {
		return "( " + this.getOperande1().toString() + " * " + this.getOperande2().toString() +")";
	}
}
