/**
 * @author Guillaume Santini
 * @version 1.0
 * Classe asbtraite permettant de décrire une expression binaire, gérant les opérandes de l'opération.
 */
public abstract class Operation extends Expression {
	
	// Définition des variables stockant les deux termes d'une opération binaire
	private Expression operande1 ;
	private Expression operande2 ;
	
	/**
	 * Constructeur par champs.
	 * @param op1 premier terme de l'opération
	 * @param op2 deuxième terme de l'opération
	 */
	public Operation(Expression op1, Expression op2) {
		this.operande1 = op1;
		this.operande2 = op2;
	}

	/**
	 * Getter permettant d'accéder à la valeur du premier opérande d'une opération.
	*/
	public Expression getOperande1() {
		return this.operande1;
	}

	/**
	 * Getter permettant d'accéder à la valeur du deuxième opérande d'une opération.
	*/
	public Expression getOperande2() {
		return this.operande2;
	}
	
	/**
	 * Contrat abstrait à redifinir pour retourner la valeur numérique résultat de l'opération.
	*/
	public abstract Double valeur();
	
	/**
	 * Redéfinition de la méthode représentant l'état d'une instance, à redéfinir dans chaque classe concrète.
	 */
	public abstract String toString();
}
